package dev.shadowsoffire.apotheosis.adventure.affix.reforging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTile;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.block_entity.TickingEntityBlock;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import dev.shadowsoffire.placebo.menu.SimplerMenuProvider;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.phys.shapes.VoxelShape;

public class ReforgingTableBlock extends Block implements TickingEntityBlock {
  public static final Component TITLE = (Component)Component.m_237115_("container.apotheosis.reforge");
  
  public static final VoxelShape SHAPE = Block.m_49796_(0.0D, 0.0D, 0.0D, 16.0D, 12.0D, 16.0D);
  
  protected final int maxRarity;
  
  public ReforgingTableBlock(BlockBehaviour.Properties properties, int maxRarity) {
    super(properties);
    this.maxRarity = maxRarity;
  }
  
  public LootRarity getMaxRarity() {
    return (LootRarity)RarityRegistry.byOrdinal(this.maxRarity).get();
  }
  
  public boolean m_7923_(BlockState pState) {
    return true;
  }
  
  public VoxelShape m_5940_(BlockState pState, BlockGetter pLevel, BlockPos pPos, CollisionContext pContext) {
    return SHAPE;
  }
  
  public InteractionResult m_6227_(BlockState state, Level world, BlockPos pos, Player player, InteractionHand handIn, BlockHitResult hit) {
    return MenuUtil.openGui(player, pos, dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingMenu::new);
  }
  
  public MenuProvider m_7246_(BlockState state, Level world, BlockPos pos) {
    return (MenuProvider)new SimplerMenuProvider(world, pos, dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingMenu::new);
  }
  
  public void m_5871_(ItemStack pStack, BlockGetter pLevel, List<Component> list, TooltipFlag pFlag) {
    list.add(Component.m_237115_(((dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableBlock)Adventure.Blocks.REFORGING_TABLE.get()).m_7705_() + ".desc").m_130940_(ChatFormatting.GRAY));
    if (this.maxRarity < ((LootRarity)RarityRegistry.getMaxRarity().get()).ordinal())
      list.add(Component.m_237110_(((dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableBlock)Adventure.Blocks.REFORGING_TABLE.get()).m_7705_() + ".desc2", new Object[] { getMaxRarity().toComponent() }).m_130940_(ChatFormatting.GRAY)); 
  }
  
  public BlockEntity m_142194_(BlockPos pPos, BlockState pState) {
    return (BlockEntity)new ReforgingTableTile(pPos, pState);
  }
  
  @Deprecated
  public void m_6810_(BlockState state, Level world, BlockPos pos, BlockState newState, boolean isMoving) {
    if (state.m_60734_() == this && newState.m_60734_() == this)
      return; 
    BlockEntity te = world.m_7702_(pos);
    if (te instanceof ReforgingTableTile) {
      ReforgingTableTile ref = (ReforgingTableTile)te;
      for (int i = 0; i < ref.inv.getSlots(); i++)
        m_49840_(world, pos, ref.inv.getStackInSlot(i)); 
    } 
    super.m_6810_(state, world, pos, newState, isMoving);
  }
}
